<?php

// +---------------------------------------------------------------------------+
// | Birthday Plugin 1.0 for Geeklog - The Ultimate Weblog                     |
// | The Happiest Plugin Ever Written                                          |
// +---------------------------------------------------------------------------+
// | index.php                                                                 |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Author: Mike Lynn <mike@mlynn.com>                                        |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -    twillett@users.sourceforge.net           |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | The Universal Plugin is based on prior work by:                           | 
// | Tony Bibbs                  -    tony@tonybibbs.com                       |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');
require_once('../../plugins/birthdays/functions.inc');
	global $T, $_TABLES, $PHP_SELF, $_CONF, $HTTP_POST_VARS, $_USER, $LANG_STATIC,$_SP_CONF;

/* 
* Main Function
*/

   $T = new Template($_CONF['path'] . 'plugins/birthdays/templates');
   $T->set_var('header', $LANG_BD00['plugin']);
   $T->set_var('site_url',$_CONF['site_url']);
   $T->set_var('plugin','birthdays');
   $T->set_var('lang_username',$LANG_BD00['username']);
   $T->set_var('lang_fullname',$LANG_BD00['fullname']);
   $T->set_var('lang_uid',$LANG_BD00['uid']);
   $T->set_var('lang_select',$LANG_BD00['select']);
   $T->set_var('lang_day',$LANG_BD00['day']);
   $T->set_var('lang_month',$LANG_BD00['month']);
   $T->set_var('lang_year',$LANG_BD00['year']);
   $T->set_var('lang_birthday',$LANG_BD00['birthday']);
   
   if ($mode == 'edit') {
	   $display .= COM_siteHeader('menu');
	   $display .= birthdayeditor($uid,$mode);
	   $display .= COM_siteFooter();
   } else if (($mode == $LANG_BD00['save']) OR ($mode == 'save')) {
	   submitbirthday($bd_id,$uid,$day,$month);
   } else if (($mode == $LANG_BD00['delete']) OR ($mode == 'delete')) {
	   $display .= COM_siteHeader('menu');
	   deletebirthday($bd_id,$uid);
	   $display .= COM_siteFooter();
   } else {
	   $display .= COM_siteHeader('menu');
	   $display .= listbirthdays($filter_month);
	   $display .= COM_siteFooter();
   }

   echo $display;

/*
* End of Main Function
*/

exit;

/* 
* Start Functions
*/

function listbirthdays($filter_month)
{
	global $T, $_TABLES, $PHP_SELF, $_CONF, $HTTP_POST_VARS, $_USER, $LANG_STATIC,$_SP_CONF;
/*
* Work from the users table to get a list of all users on the system
* Then check the birthday table for data for each users row item
*/
   $error = 0;
   $count = DB_count($_TABLES['users'],'uid');
   if ($count == 0 ) {
	   $error = 1;
   }

   $curmonth=strftime("%m")+0;
   if ($filter_month=='') {
	   $filter_month=$curmonth;
   }
   if (!($error)) {
	$T->set_file(array('list'=>'list.thtml','row'=>'row.thtml'));
	if ($filter_month == 'all') {
		$T->set_var('page_title',"Birthday Listing");
		$stmt = "SELECT * FROM {$_TABLES['users']} ";
	} else {
		$filter=" WHERE users.uid=bdays.uid and bdays.month='$filter_month'";
		$stmt = "SELECT * FROM {$_TABLES['users']} as users,{$_TABLES['birthdays']} as bdays $filter order by month, day";
		$T->set_var('page_title',"Birthday Listing for ". getMonthName($filter_month));
	}
	$T->set_var('select_month',select_month($filter_month));
	$result = DB_query("$stmt");
	$nrows = DB_numRows($result);
	if ($nrows > 0) {
		for ($i = 1; $i <=$nrows; $i++) {
			$A = DB_fetchArray($result);
			$_CONF['pagetitle'] = "Birthday Listing";
			$T->set_var('username',$A['username']);
			$T->set_var('fullname',$A['fullname']);
			$day=DB_getItem($_TABLES['birthdays'],'day',"uid = {$A["uid"]}");
			$month=DB_getItem($_TABLES['birthdays'],'month',"uid = {$A["uid"]}");
			if (SEC_hasRights('birthdays.admin') OR $A['uid']==$_USER['uid']) {
				$T->set_var('row_number', '<a href=' . COM_buildURL($_CONF['site_url'] . '/birthdays/index.php?mode=edit&amp;uid=' . $A['uid'] . '>' . $i . '</a>'));
			} else {
				$T->set_var('row_number',"$i");
			}
  
			if ($day > "") {
				$T->set_var('birthday',display_birthday($day,$month));
			} else {
				$T->set_var('birthday',"");
			}	
			$T->parse('list_item','row',true);
		}
	} else {
		$T->set_var('lang_nobdays_msg',$LANG_BD00['no_bdays']);
		$T->set_var('list_item','');
	}
   } else {
	$T->set_var('lang_nobdays_msg',$LANG_BD00['no_bdays']);
	$T->set_var('list_item','');
   }

   $T->parse('output','list');
   $display .= $T->finish($T->get_var('output'));

   return $display;
   }

function form($A, $error=false)
{
    global $_TABLES, $PHP_SELF, $_CONF, $HTTP_POST_VARS, $_USER, $LANG_BD00;
    $retval = '';
    if (!SEC_hasRights('birthdays.admin') && $A['uid']!=$_USER['uid']) {
	$error='Insufficient Rights to Edit Birthday Data.';	
    }
    if ($error) {
        $retval .= $error . "<br><br>";
    } else {
        $T = new Template($_CONF['path'] . 'plugins/birthdays/templates');
        $T->set_file('form','edit.thtml');
        $T->set_var('site_url', $_CONF['site_url']);
        $T->set_var('start_block_editor', COM_startBlock($LANG_BD00['title']));
        $T->set_var('lang_save', $LANG_BD00['save']);
        $T->set_var('lang_uid', $LANG_BD00['uid']);
        $T->set_var('lang_username', $LANG_BD00['username']);
        $T->set_var('lang_name', $LANG_BD00['name']);
        $T->set_var('lang_firstlast', $LANG_BD00['name']);
        $T->set_var('lang_month', $LANG_BD00['month']);
        $T->set_var('lang_day', $LANG_BD00['day']);
        $T->set_var('uid', $A['uid']);
        $T->set_var('username', $A['username']);
        $T->set_var('firstlast', $A['fullname']);
        $T->set_var('end_block', COM_endblock());
	$T->set_var('lang_jan',$LANG_BD00['jan']);
	$T->set_var('lang_feb',$LANG_BD00['feb']);
	$T->set_var('lang_mar',$LANG_BD00['mar']);
	$T->set_var('lang_apr',$LANG_BD00['apr']);
	$T->set_var('lang_may',$LANG_BD00['may']);
	$T->set_var('lang_jun',$LANG_BD00['jun']);
	$T->set_var('lang_jul',$LANG_BD00['jul']);
	$T->set_var('lang_aug',$LANG_BD00['aug']);
	$T->set_var('lang_sep',$LANG_BD00['sep']);
	$T->set_var('lang_oct',$LANG_BD00['oct']);
	$T->set_var('lang_nov',$LANG_BD00['nov']);
	$T->set_var('lang_dec',$LANG_BD00['dec']);
	$result = DB_query("select * from {$_TABLES['birthdays']} WHERE uid = '{$A['uid']}'");
	$B = DB_fetchArray($result);
        $month=$B['month'];
	switch( $month ) {
		case "1":
			$T->set_var('jan_selected','selected');
			break;
		case "2":
			$T->set_var('feb_selected','selected');
			break;
		case "3":
			$T->set_var('mar_selected','selected');
			break;
		case "4":
			$T->set_var('apr_selected','selected');
			break;
		case "5":
			$T->set_var('may_selected','selected');
			break;
		case "6":
			$T->set_var('jun_selected','selected');
			break;
		case "7":
			$T->set_var('jul_selected','selected');
			break;
		case "8":
			$T->set_var('aug_selected','selected');
			break;
		case "9":
			$T->set_var('sep_selected','selected');
			break;
		case "10":
			$T->set_var('oct_selected','selected');
			break;
		case "11":
			$T->set_var('nov_selected','selected');
			break;
		case "12":
			$T->set_var('dec_selected','selected');
			break;
	}
	$T->set_var('bd_id',$B['bd_id']);
        $day=$B['day'];
	$T->set_var('select_day',select_day($B['day']));
        if (SEC_hasRights('birthdays.admin') OR $A['uid']==$_USER['uid']) {
	    if (!empty($B['bd_id'])) {
		    $T->set_var('delete_option',"<input type=\"submit\" value=\"{$LANG_BD00['delete']}\" name=\"mode\">");
	    } else {
		    $T->set_var('delete_option','');
	    }
        } else {
            $T->set_var('delete_option','');
        }
        $retval .= $T->parse('output','form');
	}

    return $retval;
}

function birthdayeditor($uid, $mode = '')
{
        global $HTTP_POST_VARS, $_USER, $_CONF, $_TABLES;

        if (!empty($uid) && $mode == 'edit') {
                $result = DB_query("SELECT * FROM {$_TABLES['users']} WHERE uid = '$uid'");
                $A = DB_fetchArray($result);
        } elseif ($mode == 'edit') {
                $A['uid'] = $_USER["uid"];
        } 
        return form($A);
}

function submitbirthday($bd_id,$uid,$day,$month) {
	global $_CONF, $LANG_BD00, $_TABLES;
	$retval.=COM_siteHeader();
	if (!SEC_hasRights('birthdays.admin') && $A['uid']!=$_USER['uid']) {
		$retval='Insufficient Rights to Edit Birthday Data.';
	} else {
		if (empty($bd_id)) {
			$retval.="Inserting Birthday data...";
		} else {
			$retval.="Updating Birthday data...";
		}
		if (empty($uid) OR empty($day) OR empty($month)) {
			$retval.=COM_errorLog("Invalid birthday data: UID: [$uid] DAY: [$day] MONTH [$month]");
		} else {
			DB_save($_TABLES['birthdays'],'bd_id,uid,day,month,year',"'$bd_id','$uid','$day','$month',''",$_CONF['site_url'] . '/birthdays/');
		}
	}
	$retval.=COM_siteFooter();
	echo $retval;
}

function deletebirthday($bd_id,$uid) {
	global $_TABLES;
	if (!SEC_hasRights('birthdays.admin') && $A['uid']!=$_USER['uid']) {
		$retval='Insufficient Rights to Edit Birthday Data.';
	} else {
		if (!empty($bd_id) AND !empty($uid)) {
			$retval=DB_query("DELETE FROM {$_TABLES['birthdays']} WHERE bd_id='$bd_id'");
			if ($retval==1) {
				$retval="Deleted Birthday $bd_id!";
				$retval.="<br><a href=".$_CONF['site_url']."/birthdays>CONTINUE</a>";
			} else {
				$retval=COM_errorLog('Error while deleting birthday record.'); 
			}
		} else {
			$retval=COM_errorLog('Error while deleting birthday record.'); 
		}
	}
	echo $retval;
}
